#ifndef	HASH_H
#define	HASH_H
#include	<stdlib.h>
#include	<glib.h>

/* If the values in the hash are char pointers, pointing to
   null-terminated character arrays, then use STRING_VALS as the
   "size" parameter when creating a new hash with new_hash(). */
#define		STRING_VALS	0

/* Convenience macros.  
   Watch out, because my_hash_t->lookup() will return NULL when there
   is nothing in the hash at the given key.  This macro always
   dereferences the return value, so don't use it if there's a risk of
   trying to dereference the null pointer. */
#define		LOOKUP(hash, type, key)		\
	(*((type *)(hash->lookup(hash, key))))
#define		LOOKUP_STRVAL(hash, key)		\
	((char *)(hash->lookup(hash, key)))
/* To be used when we're done with the hash. */
#define		FREE_HASH(hp)    hp->destroy(hp); g_free(hp);

typedef
struct hashorama {
  GHashTable		*htp;
  /* Size of the object (in memory) stored in the hash.
     Zero for a null-terminated char array.   */
  size_t		data_size;
  
  void 	(*ins)		(struct hashorama *, 
			 const char *key,
			 gpointer value);
  gpointer (*lookup)	(struct hashorama *, const char *key);
  void	(*destroy)	(struct hashorama *);
} hash_t;

hash_t *new_hash(size_t data_size);
#endif /* !HASH_H */
