/*
 *	An easy to use static buffer system for holding strings.
 *	"Static" because the point is to have 
 */
#include	<stdlib.h>
#include	<stdio.h>

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *	
 * 	NOTE: the following defined values are meant to be overridden
 *		when desired, but be careful that the definition gets
 *		to all the files it needs to.  (use the -D flag in
 *		the makefile.)
 */
/* how many pointers for strings in the chunk */
#ifndef		MAX_STRINGS
#define		MAX_STRINGS	10
#endif
/* how big of a chunk for holding strings */
#ifndef		CHUNK_SIZE
#define		CHUNK_SIZE	BUFSIZ
#endif
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

#define		SSBUFF_ERR	-1

struct static_string_buffer 
{
  /*
   * The current (i.e., next available, string slot is at
   *	strings[n_strings]
   */
  int		n_strings;
  /* a null-terminated vector of char pointers */
  char		*strings[MAX_STRINGS + 1];
  /* number of bytes available in the chunk */
  size_t	avail;
  char		chunk[CHUNK_SIZE];

  size_t	(*add)(struct static_string_buffer *sbuf_p,
		       const char *str);
  size_t	(*clear)(struct static_string_buffer *sbuf_p);
};
typedef struct static_string_buffer strbuf_t;

size_t strbuf_init(strbuf_t *sbuf_p);


/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */

