/* 
   Ed Cashin, cashin
   CS 202, Summer 1998
   Lab: M/W - 6th
   
   Prof. E. M. Lether
   Program #3:	Section 13.1, Programming Project 2 (Shiflet), p.801
   Due:	Tuesday, July 21
   Late Due Date: Sunday, July 26
   
   vector.h ---
   makes vector's interface available to the world.

   (This file was written June 21, before the assignment, but is very
   handy in the crossword assignment for remembering the positions in
   the grid where words can go.)

   News: 

   For program assignment 3 there were a bunch of conveniences added
   to make it easier to use a vector for storing strings.  The
   "FREE_VEC" macro was added after I noticed myself forgetting to
   free one of the two: the vector's array and the vector structure
   itself.  */

#ifndef		VECTOR_H
#define		VECTOR_H

#include	<stdio.h>

#define		FREE_VEC(vec)			\
 	(vec)->destroy((vec)); 	xfree((vec)); 

struct vector
{
  /* Shows how many elements are in the vector. */
  size_t	n_elems;
  /* Shows how much space one element needs in bytes. */
  size_t	elem_size;
  /* Shows how much memory is currently allocated for vector's
     elements. */
  size_t	alloced_mem;
  /* Shows how many more bytes to allocate whenever the vector must
     grow. */
  size_t	delta;
  /* These are pointers to functions that are defined in vector.c. */
  void 		(*add)		(struct vector *, const void *elem);
  void 		*(*index)	(struct vector *, int idx);
  void 		(*destroy)	(struct vector *);
  void 		(*clear)	(struct vector *);
  /* pointer to the memory allocated for the dynamic array */
  char		*vec_start;
};
typedef struct vector vec_t;


/* This is the only function in vector.c that is not accessed through
   one of the vec_t pointer-to-function members. */
vec_t *new_vec(size_t elem_size);

/* These are prototypes for the character vector functions. */
vec_t *chv_cat(vec_t *chv, const char *str);
vec_t *chvec_cat(vec_t *chv, const char *str, int n);
vec_t *chv_cpy(vec_t *chv, const char *str);
vec_t *chvec_cpy(vec_t *chv, const char *str, int n);
char *chv2str(vec_t *chv);
void chv_set(vec_t *chv, char *filler_p, int n);
int fprint_chv(FILE *ofile, vec_t *chv);
int print_chv(vec_t *chv);

#endif		/* no VECTOR_H */
